package org.rcisoft.business.opmArticle.dao;


import com.baomidou.mybatisplus.core.metadata.IPage;
import org.apache.ibatis.annotations.Param;
import org.rcisoft.business.opmArticle.entity.ArticleCommentDTO;
import org.rcisoft.business.opmArticle.entity.ArticleCommentVO;
import org.rcisoft.business.opmArticle.entity.LikeDTO;
import org.rcisoft.business.opmArticle.entity.OpmArticle;
import org.rcisoft.core.mapper.CyBaseMapper;
import org.rcisoft.core.model.CyPageInfo;

import javax.persistence.criteria.CriteriaBuilder;
import java.util.List;


/**
* Created with cy on 2024年3月30日 下午1:51:15.
*/

public interface OpmArticleRepository extends CyBaseMapper<OpmArticle> {


    List<OpmArticle> queryOpmArticle(@Param("entity") OpmArticle cmsBanner);

    /**
    * 管理端-分页查询 OpmArticle
    *
    */
    IPage<OpmArticle> queryOpmArticlePaged(CyPageInfo cyPageInfo, @Param("entity") OpmArticle opmArticle);

    //app-最近-分页查询 OpmArticle
    IPage<OpmArticle> appQueryOpmArticlePaged(CyPageInfo cyPageInfo, @Param("entity") OpmArticle opmArticle);

    //app-话题-分页查询 OpmArticle
    IPage<OpmArticle> appQueryTopicOpmArticlePaged(CyPageInfo<OpmArticle> paginationUtility,@Param("entity") OpmArticle opmArticle);

    //app-关注-分页查询 OpmArticle
    IPage<OpmArticle> appQueryFollowOpmArticlePaged(CyPageInfo<OpmArticle> paginationUtility,@Param("entity") OpmArticle opmArticle);

    OpmArticle selectArticleDetail(@Param("articleId") Integer articleId, @Param("loginUserId") String loginUserId);

    //web查询评论
    List<ArticleCommentVO> selectArticleComment(@Param("articleId") Integer articleId, @Param("loginUserId") String loginUserId);

    //app查询评论
    List<ArticleCommentVO> appSelectArticleComment(@Param("articleId") Integer articleId, @Param("loginUserId") String loginUserId);

    //查询评论下的子评论
    List<ArticleCommentVO> appSelectArticleChildrenComment(@Param("articleId") Integer articleId, @Param("parentId") Integer parentId, @Param("loginUserId") String loginUserId);

    //查询评论下的子评论
    List<ArticleCommentVO> selectArticleChildrenComment(@Param("articleId") Integer articleId, @Param("parentId") Integer parentId, @Param("loginUserId") String loginUserId);

    //删除评论
    int deleteComment(ArticleCommentDTO dto);

    //添加点赞记录
    int likeAdd(@Param("entity") LikeDTO likeDTO);

    //删除点赞记录
    int likeDelete(@Param("userId") String userId,@Param("commentId") Integer commentId);

    //动态点赞数+1
    int addLikeCount(Integer articleId);

    //评论点赞数+1
    int addCommentLikeCount(Integer commentId);

    //动态点赞数-1
    int reduceLikeCount(Integer articleId);

    //评论点赞数-1
    int reduceCommentLikeCount(Integer commentId);

    //动态表评论数+1
    int addArticleCommentCount(Integer articleId);

    //动态表评论数-1
    int reduceArticleCommentCount(Integer articleId);

    //评论表评论数-1
    int reduceCommentCount(Integer commentId);

    //评论表评论数+1
    int addCommentCount(Integer commentId);

    //添加动态评论
    int addComment(@Param("entity") ArticleCommentDTO dto);

    //查询某个人的动态列表
    IPage<OpmArticle> queryUserArticlePaged(CyPageInfo cyPageInfo, @Param("entity") OpmArticle opmArticle);

    //根据id查询评论信息
    ArticleCommentDTO findCommentById(Integer businessId);

    //根据动态id查询动态评论
    List<ArticleCommentVO> selectArticleCommentCount(@Param("entity") OpmArticle article);

    //根据评论id查询子评论数量
    Integer selectArticleChildrenCommentCount(@Param("entity") ArticleCommentVO article);

    //根据评论id修改动态的评论数量
    int updateCommentById(@Param("entity") ArticleCommentVO commentVo);

    //根据id查询评论信息
    ArticleCommentVO selectCommentById(Integer businessId);

    //根据动态id修改动态的评论数量
    int updateArticleCommentCountById(@Param("entity") OpmArticle article);

    void updateArticleExamStatus(Integer articleId);

    void updateArticleCommentExamStatus(@Param("entity") OpmArticle article);
}

