package org.rcisoft.business.sysScheduledTaskLog.service.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.rcisoft.core.util.CyUserUtil;
import org.rcisoft.core.aop.CyPageUtilAsp;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.util.CyEpExcelUtil;
import org.rcisoft.business.sysScheduledTaskLog.dao.SysScheduledTaskLogRepository;
import org.rcisoft.business.sysScheduledTaskLog.entity.SysScheduledTaskLog;
import org.rcisoft.business.sysScheduledTaskLog.service.SysScheduledTaskLogService;
import org.rcisoft.core.service.CyBaseService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import org.rcisoft.core.model.CyPageInfo;

import java.util.List;
import lombok.extern.slf4j.Slf4j;

/**
 * Created by cy on 2025年2月20日 上午11:14:19.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class SysScheduledTaskLogServiceImpl extends ServiceImpl<SysScheduledTaskLogRepository,SysScheduledTaskLog>  implements SysScheduledTaskLogService {


    /**
    * 保存 
    * @param sysScheduledTaskLog
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel persist(SysScheduledTaskLog sysScheduledTaskLog){
        //增加操作
        int line = baseMapper.insert(sysScheduledTaskLog);
        log.debug(CyUserUtil.getAuthenUsername()+"新增了ID为"+
            sysScheduledTaskLog.getBusinessId()+"的信息");
        return new CyPersistModel(line);
    }

    /**
    * 删除 
    * @param sysScheduledTaskLog
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel remove(SysScheduledTaskLog sysScheduledTaskLog){
        int line = baseMapper.realDelete(sysScheduledTaskLog);
        log.debug(CyUserUtil.getAuthenUsername()+"删除了ID为"+
            sysScheduledTaskLog.getBusinessId()+"的信息");
        return new CyPersistModel(line);
    }

    /**
    * 修改 
    * @param sysScheduledTaskLog
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public CyPersistModel merge(SysScheduledTaskLog sysScheduledTaskLog){
        int line = baseMapper.updateById(sysScheduledTaskLog);
        log.debug(CyUserUtil.getAuthenUsername()+"修改了ID为"+ sysScheduledTaskLog.getBusinessId()+"的信息");
        return new CyPersistModel(line);
    }

    /**
    * 根据id查询 
    * @param id
    * @return
    */
    @Override
    public SysScheduledTaskLog findById(String id){
        return baseMapper.selectById(id);
    }

    /**
    * 分页查询 
    * @param sysScheduledTaskLog
    * @return
    */
    @Override
    public IPage<SysScheduledTaskLog> findAllByPagination(CyPageInfo<SysScheduledTaskLog> paginationUtility,
        SysScheduledTaskLog sysScheduledTaskLog){
        return baseMapper.querySysScheduledTaskLogsPaged(paginationUtility,sysScheduledTaskLog);

    }

    /**
    * 查询list 
    * @param sysScheduledTaskLog
    * @return
    */
    @Override
    public List<SysScheduledTaskLog> findAll(SysScheduledTaskLog sysScheduledTaskLog){
        return baseMapper.querySysScheduledTaskLogs(sysScheduledTaskLog);

    }

    /**
    * 导出
    * @return
    */
    @Override
    public List<SysScheduledTaskLog> export(SysScheduledTaskLog sysScheduledTaskLog) {
        List<SysScheduledTaskLog> sysScheduledTaskLogList = baseMapper.querySysScheduledTaskLogs(sysScheduledTaskLog);
        return sysScheduledTaskLogList;
    }

}
